package com.jz.common.filter;

import java.io.IOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.jz.common.service.PatternMatcher;
import com.jz.common.service.ServletPathMatcher;
import com.jz.dmp.modules.service.AtomBaseCacheService;

import lombok.extern.slf4j.Slf4j;
import nl.bitwalker.useragentutils.Browser;
import nl.bitwalker.useragentutils.OperatingSystem;
import nl.bitwalker.useragentutils.UserAgent;

/**
 * 
 * @ClassName: LoginFilter 
 * @Description: TODO(这里用一句话描述这个类的作用) 
 * @author: niulichang
 * @date: 2020年6月10日 下午4:27:06
 * @最后修改人: niulichang
 * @最后修改时间: 2020年6月10日 下午4:27:06
 */
@Component
@Slf4j
public class LoginFilter implements Filter {

	@Autowired
	private AtomBaseCacheService<String> cacheService;
	
	
	public static final String PARAM_NAME_EXCLUSIONS = "exclusions";
    private Set<String> excludesPattern;
    protected String contextPath;
    protected PatternMatcher pathMatcher = new ServletPathMatcher();
    public String getContextPath() {
        return contextPath;
    }

    public void setContextPath(String contextPath) {
        this.contextPath = contextPath;
    }

	@Override
    public void init(FilterConfig filterConfig) throws ServletException {
		String param = filterConfig.getInitParameter(PARAM_NAME_EXCLUSIONS);
        if (param != null && param.trim().length() != 0) {
        	this.excludesPattern = new HashSet(Arrays.asList(param.split("\\s*,\\s*")));
        }
    }
	@Override
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
			throws IOException, ServletException {
		HttpServletRequest httpRequest = (HttpServletRequest) request;
        HttpServletResponse httpResponse = (HttpServletResponse) response;

        String ua = httpRequest.getHeader("User-Agent");
        UserAgent userAgent = UserAgent.parseUserAgentString(ua);
        Browser browser = userAgent.getBrowser();
        OperatingSystem os = userAgent.getOperatingSystem();
        String system = os.getName();
        String browserName = browser.getName();
		String token = httpRequest.getHeader("token");
		httpResponse.setHeader("Access-Control-Allow-Origin", "http://zhijie-admin.9zdata.cn"); //允许来之域名为http://localhost的请求        
		httpResponse.setHeader("Access-Control-Allow-Headers", "Origin,No-Cache, X-Requested-With, If-Modified-Since, Pragma, Last-Modified, Cache-Control, Expires, Content-Type, X-E4M-With, userId, token");
		httpResponse.setHeader("Access-Control-Allow-Methods", "POST, GET, OPTIONS, DELETE"); //请求允许的方法
		httpResponse.setHeader("Access-Control-Max-Age", "3600"); 
		httpResponse.setCharacterEncoding("UTF-8");
        httpResponse.setContentType("application/json; charset=utf-8");
        String resMethods =  httpRequest.getMethod();
        if("OPTIONS".equals(resMethods)) {
        	Map<String, Object> map = new HashMap<String, Object>();
        	map.put("data",null);
        	map.put("code","200");
        	map.put("msg",null);
        	log.info(JSONObject.toJSONString(map, SerializerFeature.WriteMapNullValue));
        	httpResponse.getWriter().write(JSONObject.toJSONString(map, SerializerFeature.WriteMapNullValue));
          return;
        }
//		String requestURL = httpRequest.getRequestURI();
//		if (this.isExclusion(requestURL)) {
//			chain.doFilter(httpRequest,httpResponse);
//        }else {
//        	String userId = null;
//            Claims claims = JwtUtil.checkJWT(token);
//            if (claims != null) {
//            	userId = (String) claims.get("userId");
//            } else {
//               PrintWriter out = httpResponse.getWriter();
//               JSONObject res = new JSONObject();
//               res.put("msg", ResultCode.E9998.msg());
//               res.put("code", ResultCode.E9998.val());
//               res.put("data",null);
//               out.append(res.toString());
//               out.flush();
//               return;
//           }
//            String tokenSystem = (String) claims.get("system");
//            String tokenBrowserName = (String) claims.get("browserName");
//            if(!system.equals(tokenSystem)|| !browserName.equals(tokenBrowserName)) {
//            	 PrintWriter out = httpResponse.getWriter();
//                 JSONObject res = new JSONObject();
//                 res.put("msg", ResultCode.E9998.msg());
//                 res.put("code", ResultCode.E9998.val());
//                 res.put("data",null);
//                 out.append(res.toString());
//                 out.flush();
//                 return;
//            }
//           if (userId==null){
//               PrintWriter out = httpResponse.getWriter();
//               JSONObject res = new JSONObject();
//               res.put("msg", ResultCode.E9998.msg());
//               res.put("code", ResultCode.E9998.val());
//               res.put("data",null);
//               out.append(res.toString());
//               out.flush();
//               return;
//           }else {
//        	   String access_token = cacheService.getValue("access_token"+userId);
//        	   if(StringUtils.isBlank(access_token)|| !token.equals(access_token)) {
//                   PrintWriter out = httpResponse.getWriter();
//                   JSONObject res = new JSONObject();
//                   res.put("msg", ResultCode.E9998.msg());
//                   res.put("code", ResultCode.E9998.val());
//                   res.put("data",null);
//                   out.append(res.toString());
//                   out.flush();
//                   return;
//        	   }        	   
//        	   cacheService.expire("access_token"+userId, Constants.ACCESS_EXPIRE, java.util.concurrent.TimeUnit.SECONDS);
//        	   List<String> menu = systemMenuService.getMenuHrefListForLoginUser(Integer.parseInt(userId));
//        	   if(!menu.contains(requestURL)) {
//        		   PrintWriter out = httpResponse.getWriter();
//                   JSONObject res = new JSONObject();
//                   res.put("msg", ResultCode.INVALID_AUTHCODE.msg());
//                   res.put("code", ResultCode.INVALID_AUTHCODE.val());
//                   res.put("data",null);
//                   out.append(res.toString());
//                   out.flush();
//                   return;
//        	   }
//        	   chain.doFilter(httpRequest,httpResponse);
//           }
//        }
        chain.doFilter(httpRequest,httpResponse);
	}
	
	@Override
    public void destroy() {

    }

	public boolean isExclusion(String requestURI) {
        if (this.excludesPattern == null) {
            return false;
        } else {
            if (this.contextPath != null && requestURI.startsWith(this.contextPath)) {
                requestURI = requestURI.substring(this.contextPath.length());
                if (!requestURI.startsWith("/")) {
                    requestURI = "/" + requestURI;
                }
            }
            Iterator i$ = this.excludesPattern.iterator();
            String pattern;
            do {
                if (!i$.hasNext()) {
                    return false;
                }
                pattern = (String)i$.next();
            } while(!this.pathMatcher.matches(pattern, requestURI));

            return true;
        }
    }

	
}
