package com.jz.dmp.modules.controller.bean;

import java.util.Date;
import com.jz.common.annotation.FieldAssist;
import com.jz.common.bean.BasePageBean;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**操作日志表参数请求封装
 * @author ybz
 *
 */
@ApiModel(value = "操作日志表参数请求封装", description = "操作日志表参数请求封装")
public class DmpOptLogRequest extends BasePageBean {
	/**
	* 主键
	*/
	@ApiModelProperty(value = "主键")
	@FieldAssist(orderBy = "_log.opt_id")
	private Integer optId;

	/**
	* 操作人ID
	*/
	@ApiModelProperty(value = "操作人ID")
	@FieldAssist(orderBy = "_log.user_id")
	private Integer userId;

	/**
	* 操作人姓名
	*/
	@ApiModelProperty(value = "操作人姓名")
	@FieldAssist(orderBy = "_log.user_name")
	private String userName;

	/**
	* 
	*/
	@ApiModelProperty(value = "")
	@FieldAssist(orderBy = "_log.user_roles")
	private String userRoles;

	/**
	* 操作时间
	*/
	@ApiModelProperty(value = "操作时间")
	@FieldAssist(orderBy = "_log.opt_time")
	private Date optTime;

	/**
	* 操作时间起
	*/
	@ApiModelProperty(value = "操作时间起")
	private Date optTimeStart;

	/**
	* 操作时间止
	*/
	@ApiModelProperty(value = "操作时间止")
	private Date optTimeEnd;

	/**
	* 操作功能模块
	*/
	@ApiModelProperty(value = "操作功能模块")
	@FieldAssist(orderBy = "_log.opt_modular")
	private String optModular;

	/**
	* 操作类型
	*/
	@ApiModelProperty(value = "操作类型")
	@FieldAssist(orderBy = "_log.opt_type")
	private String optType;

	/**
	* 操作描述
	*/
	@ApiModelProperty(value = "操作描述")
	@FieldAssist(orderBy = "_log.opt_desc")
	private String optDesc;

	/**
	* 操作方法
	*/
	@ApiModelProperty(value = "操作方法")
	@FieldAssist(orderBy = "_log.method")
	private String method;

	/**
	* 请求参数
	*/
	@ApiModelProperty(value = "请求参数")
	@FieldAssist(orderBy = "_log.request_param")
	private String requestParam;

	/**
	* 操作结果
	*/
	@ApiModelProperty(value = "操作结果")
	@FieldAssist(orderBy = "_log.opt_result")
	private String optResult;

	/**
	* IP地址
	*/
	@ApiModelProperty(value = "IP地址")
	@FieldAssist(orderBy = "_log.opt_ip")
	private String optIp;

	/**
	* 
	*/
	@ApiModelProperty(value = "")
	@FieldAssist(orderBy = "_log.project_id")
	private Integer projectId;

	/**
	* 备注
	*/
	@ApiModelProperty(value = "备注")
	@FieldAssist(orderBy = "_log.remark")
	private String remark;

	/**
	* 数据状态(0：删除，1，未删除)
	*/
	@ApiModelProperty(value = "数据状态(0：删除，1，未删除)")
	@FieldAssist(orderBy = "_log.data_status")
	private String dataStatus;

	/**
	* 创建用户ID
	*/
	@ApiModelProperty(value = "创建用户ID")
	@FieldAssist(orderBy = "_log.create_user_id")
	private Integer createUserId;

	/**
	* 创建时间
	*/
	@ApiModelProperty(value = "创建时间")
	@FieldAssist(orderBy = "_log.create_time")
	private Date createTime;

	/**
	* 创建时间起
	*/
	@ApiModelProperty(value = "创建时间起")
	private Date createTimeStart;

	/**
	* 创建时间止
	*/
	@ApiModelProperty(value = "创建时间止")
	private Date createTimeEnd;

	/**
	* 修改用户ID
	*/
	@ApiModelProperty(value = "修改用户ID")
	@FieldAssist(orderBy = "_log.update_user_id")
	private Integer updateUserId;

	/**
	* 修改时间
	*/
	@ApiModelProperty(value = "修改时间")
	@FieldAssist(orderBy = "_log.update_time")
	private Date updateTime;

	/**
	* 修改时间起
	*/
	@ApiModelProperty(value = "修改时间起")
	private Date updateTimeStart;

	/**
	* 修改时间止
	*/
	@ApiModelProperty(value = "修改时间止")
	private Date updateTimeEnd;

	public Integer getOptId() {
		return optId;
	}

	public void setOptId(Integer optId) {
		this.optId = optId;
	}

	public Integer getUserId() {
		return userId;
	}

	public void setUserId(Integer userId) {
		this.userId = userId;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public String getUserRoles() {
		return userRoles;
	}

	public void setUserRoles(String userRoles) {
		this.userRoles = userRoles;
	}

	public Date getOptTime() {
		return optTime;
	}

	public void setOptTime(Date optTime) {
		this.optTime = optTime;
	}

	public Date getOptTimeStart() {
		return optTimeStart;
	}

	public void setOptTimeStart(Date optTimeStart) {
		this.optTimeStart = optTimeStart;
	}

	public Date getOptTimeEnd() {
		return optTimeEnd;
	}

	public void setOptTimeEnd(Date optTimeEnd) {
		this.optTimeEnd = optTimeEnd;
	}

	public String getOptModular() {
		return optModular;
	}

	public void setOptModular(String optModular) {
		this.optModular = optModular;
	}

	public String getOptType() {
		return optType;
	}

	public void setOptType(String optType) {
		this.optType = optType;
	}

	public String getOptDesc() {
		return optDesc;
	}

	public void setOptDesc(String optDesc) {
		this.optDesc = optDesc;
	}

	public String getMethod() {
		return method;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getRequestParam() {
		return requestParam;
	}

	public void setRequestParam(String requestParam) {
		this.requestParam = requestParam;
	}

	public String getOptResult() {
		return optResult;
	}

	public void setOptResult(String optResult) {
		this.optResult = optResult;
	}

	public String getOptIp() {
		return optIp;
	}

	public void setOptIp(String optIp) {
		this.optIp = optIp;
	}

	public Integer getProjectId() {
		return projectId;
	}

	public void setProjectId(Integer projectId) {
		this.projectId = projectId;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getDataStatus() {
		return dataStatus;
	}

	public void setDataStatus(String dataStatus) {
		this.dataStatus = dataStatus;
	}

	public Integer getCreateUserId() {
		return createUserId;
	}

	public void setCreateUserId(Integer createUserId) {
		this.createUserId = createUserId;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public Date getCreateTimeStart() {
		return createTimeStart;
	}

	public void setCreateTimeStart(Date createTimeStart) {
		this.createTimeStart = createTimeStart;
	}

	public Date getCreateTimeEnd() {
		return createTimeEnd;
	}

	public void setCreateTimeEnd(Date createTimeEnd) {
		this.createTimeEnd = createTimeEnd;
	}

	public Integer getUpdateUserId() {
		return updateUserId;
	}

	public void setUpdateUserId(Integer updateUserId) {
		this.updateUserId = updateUserId;
	}

	public Date getUpdateTime() {
		return updateTime;
	}

	public void setUpdateTime(Date updateTime) {
		this.updateTime = updateTime;
	}

	public Date getUpdateTimeStart() {
		return updateTimeStart;
	}

	public void setUpdateTimeStart(Date updateTimeStart) {
		this.updateTimeStart = updateTimeStart;
	}

	public Date getUpdateTimeEnd() {
		return updateTimeEnd;
	}

	public void setUpdateTimeEnd(Date updateTimeEnd) {
		this.updateTimeEnd = updateTimeEnd;
	}
}
