package com.jz.dmp.modules.controller.dataOperation.bean;


import com.jz.common.page.BasePageBean;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @ClassName: SetSlaRulesReq
 * @Description: 数据运维-SLA请求参数
 * @Author：Bellamy
 * @Date 2021/01/13
 * @Version 1.0
 */
@Data
@ApiModel(value = "SLA请求参数", description = "SLA请求参数")
public class SetSlaRulesReq implements Serializable {

    private static final long serialVersionUID = 7548870996371216281L;
    @ApiModelProperty(value = "flow/job")
    @NotNull(message = "flow/job不能为空")
    @NotEmpty(message = "flow/job不能为空")
    private String flow;

    @ApiModelProperty(value = "sla 规则")
    private String slaRule;

    @ApiModelProperty(value = "duration")
    private String duration;

    @ApiModelProperty(value = "邮件通知")
    private Boolean emailNotification;

    @ApiModelProperty(value = "kill")
    private Boolean kill;

}
