package com.jz.dmp.modules.controller.dataService.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @ClassName: SaltResetReq
 * @Description: 盐值重置请求对象
 * @Author: Bellamy
 * @Date 2021/2/20
 * @Version 1.0
 */
@Data
@ApiModel("盐值重置请求对象")
public class SaltResetReq implements Serializable {

    @ApiModelProperty(value = "授权码", required = true)
    @NotNull(message = "授权码不能为空")
    @NotEmpty(message = "授权码不能为空")
    private String authCode;

    @ApiModelProperty(value = "更新用户", required = false)
    private String updateUser;
}
